<template>
  <div class="workCompany pagePadding">
    <div v-if="powers.some((i) => i == '001')">
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 10px 80px">
              <el-col :span="6" style="width: 303px">
                <period-date-picker
                  :type="1"
                  :width="'135px'"
                  :size="searchSize"
                  :start="parmValue.start"
                  :end="parmValue.end"
                  @timeReturned="handleTime"
                />
              </el-col>
              <el-col :span="4" style="width: 160px">
                <el-select
                  v-model="parmValue.status"
                  filterable
                  clearable
                  :size="searchSize"
                  placeholder="状态"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in statusOptions"
                    :key="'status' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>

              <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
                <el-button type="primary" :size="searchSize" @click="searchList">
                  刷新
                </el-button>
              </el-col>
              <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
                <el-button type="warning" :size="searchSize" @click="restSearch">
                  重置
                </el-button>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="4" style="width: 373px">
                <el-input
                  :size="searchSize"
                  v-model="parmValue.company"
                  :maxlength="40"
                  @blur="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                  placeholder="公司名称"
                ></el-input>
              </el-col>
              <el-col :span="4" style="width: 170px; padding: 0 0 0 10px">
                <el-input
                  :size="searchSize"
                  v-model="parmValue.creater"
                  :maxlength="40"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                  placeholder="负责人"
                ></el-input>
              </el-col>
              <el-col :span="4" style="width: 170px; padding: 0 0 0 10px">
                <el-input
                  :size="searchSize"
                  v-model="parmValue.company_name"
                  :maxlength="40"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                  placeholder="负责人部门"
                ></el-input>
              </el-col>
              <el-col
                :span="3"
                class="fr"
                style="width: 66px; padding: 0 0 0 10px"
                v-if="powers.some((i) => i == '003')"
              >
                <el-button
                  :size="searchSize"
                  type="success"
                  style="float: right"
                  @click="openModal({}, '003')"
                >
                  添加
                </el-button>
              </el-col>
            </el-row>
          </div></template
        >
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {}).label ||
              '--'
            "
          ></el-tag>
        </template>

        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i class="el-icon-view tb-icon" @click="openModal(scope.row, '007')"></i>
          </el-tooltip>
          <el-tooltip
            v-if="powers.some((i) => i == '005')"
            effect="dark"
            content="修改"
            placement="top"
          >
            <i class="el-icon-edit tb-icon" @click="openModal(scope.row, '005')"></i>
          </el-tooltip>
          <el-tooltip
            v-if="powers.some((i) => i == '004') && scope.row.status === '1'"
            effect="dark"
            content="禁用"
            placement="top"
          >
            <i
              class="el-icon-video-pause tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="powers.some((i) => i == '004') && scope.row.status === '0'"
            effect="dark"
            content="启用"
            placement="top"
          >
            <i
              class="el-icon-video-play tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="powers.some((i) => i == '006')"
            effect="dark"
            content="删除"
            placement="top"
          >
            <i class="el-icon-delete tb-icon" @click="deleteById(scope.row.id)"></i>
          </el-tooltip>
        </template>
      </ex-table>
      <add-edit
        :id="modelId"
        :show-model="showModel"
        :is-detail="isDetail"
        @refresh="searchList"
        @cancel="showModel = false"
      />
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/serviceParam/workCompany";
import addEdit from "./addEdit";
import { mapGetters } from "vuex";
export default {
  name: "workCompany",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find((item) => item.menu_route == "workCompany") ||
        {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      select: "1", //选择
      input: "",
      supplierNo: [], //供应商
      stock_sn: "", //企业/仓库编码
      stock_name: "", //企业/仓库名称
      link: "", //联系电话/联系人
      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        supplierNo: "", //供应商编码
        wsm_code: "", //仓库编码
        start: "", //新建起始时间
        company_name: "", //负责人部门
        end: "", //新建结束时间
        mobile: "", //手机号
        contactor: "", //联系人
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: [
        {
          prop: "companyNo",
          label: "编号",
          width: "170px",
        },

        {
          prop: "company",
          label: "公司名称",
        },
        {
          prop: "status",
          label: "状态",
          width: "100px",
          _slot_: "status",
        },
        {
          prop: "company_name",
          label: "负责人部门",
          minWidth: "150px",
        },
        {
          prop: "creater",
          label: "负责人",
          width: "100px",
        },

        {
          prop: "addtime",
          label: "创建时间",
          width: "145px",
        },
        {
          prop: "",
          label: "操作",
          width: "140px",
          fixed: "right",
          _noset_: true,
          _slot_: "operation",
        },
      ],
      // 状态
      statusOptions: [
        { id: "0", label: "禁用" },
        { id: "1", label: "启用" },
      ],
    };
  },
  mounted() {
    this.searchList();
  },

  methods: {
    // 时间
    async handleTime(e) {
      this.parmValue.start = e.startTime || "";
      this.parmValue.end = e.endTime || "";
      if (
        (this.parmValue.start !== "" && this.parmValue.end !== "") ||
        (this.parmValue.start === "" && this.parmValue.end === "")
      ) {
        // this.pageInfo.curr = 1;
        // this.parmValue.page = 1;
        await this.searchList();
      }
    },
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.supplierNo = [];
      this.input = "";
      this.select = "1";
      this.parmValue = {
        supplierNo: "", //供应商编码
        wsm_code: "", //仓库编码
        start: "", //新建起始时间
        company_name: "", //负责人部门
        end: "", //新建结束时间
        mobile: "", //手机号
        contactor: "", //联系人
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      this.searchList();
    },

    openModal(row, type) {
      const { status } = row;
      if (type === "005" && status === "1") {
        this.$message.warning("禁用后，才可以修改！");
        return;
      }
      this.showModel = true;
      this.modelId = row.companyNo;
      this.isDetail = type;
    },
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start == "" && this.parmValue.end != "")
      ) {
        this.$message.warning("开始时间和结束时间不能为空");
        return;
      }
      this.loading = true;
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async deleteById(id) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
  },
};
</script>
<style lang="scss" scoped></style>
